#extension GL_OES_standard_derivatives:enable

precision highp float;


uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform highp vec2 realWH;


vec4 AntiAliasPointSampleTexture_Linear(vec2 uv, vec2 texsize) {
    vec2 w=fwidth(uv);
    return texture2D(inputImageTexture, (floor(uv)+0.5 + clamp((fract(uv)-0.5+w)/w, 0., 1.)) / texsize, 0.0);
}

vec4 AntiAliasPointSampleTexture_ModifiedFractal(vec2 uv, vec2 texsize) {
    uv.xy -= 0.5;
    vec2 w=fwidth(uv);
    return texture2D(inputImageTexture, (floor(uv)+0.5+min(fract(uv)/min(w, 1.0), 1.0)) / texsize, -99999.0);
}

vec2 saturate(vec2 x)
{
    return clamp(x, 0.0, 1.0);
}

vec2 magnify(vec2 uv)
{
    uv *= realWH.xy;
    return (saturate(fract(uv) / saturate(fwidth(uv))) + floor(uv) - 0.5) / realWH.xy;
}

vec2 quantize(vec2 uv)
{
    return (floor(uv * realWH.xy) + 0.5) / realWH.xy;
}


void main (void){

    vec2 realWH1 = realWH;

    float x = textureCoordinate.x*realWH1.x;
    float y = textureCoordinate.y*realWH1.y;

    vec2 realPos = vec2(x, y);
    highp vec4  color;

    vec2 resultXY = magnify(textureCoordinate.xy);
    color =  texture2D(inputImageTexture, resultXY);


//    highp vec4 color = texture2D(inputImageTexture, textureCoordinate.xy);
    gl_FragColor = color;

}