precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform highp float ratio;
const highp vec3 W = vec3(0.2125, 0.7154, 0.0721);


void main()
{
  lowp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
  float luminance = dot(textureColor.rgb, W);

  vec4 grayColor = vec4(vec3(luminance), textureColor.a);
  gl_FragColor=vec4(mix(textureColor.rgb,grayColor.rgb,ratio*grayColor.a),textureColor.a);

}





