precision highp float;
uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
uniform highp vec2 realWH;
uniform highp float ratio;//模糊半径

float T;

#define pi 3.1415926

vec2 hash(vec2 p) {
    p=vec2(dot(p, vec2(127.1, 311.7)), dot(p, vec2(269.5, 183.3)));
    return fract(sin(p)*18.5453);
}

float random(vec2 p)
{
    return fract(sin(dot(p.xy, vec2(12.9898, 78.233)))*43758.5453123);
}


vec2 getRandomPoint(vec2 curPos, float gridW)
{

    float curWNumGrid = floor(curPos.x/gridW);
    float curHNumGrid = floor(curPos.y/gridW);

    vec2 leftTopPosReal = vec2(gridW*curWNumGrid, gridW*curHNumGrid);

    float mindist = 1e9;
    vec2 resultPos = vec2(-1.0, -1.0);



    for (float y = -1.0; y <= 1.0; y++){
        for (float x = -1.0; x <= 1.0; x++)
        {
            vec2 offset = vec2(x*gridW, y*gridW);
            vec2 curP =leftTopPosReal+vec2(gridW/2.0, gridW/2.0)+offset;//当前格子中心点
            float randomValueX = clamp(random(curP.xy),0.0,1.0);
            float randomValueY = clamp(random(curP.yx),0.0,1.0);

            vec2 randomPosReal = curP + vec2(randomValueX - 0.5, randomValueX - 0.5)*gridW;

            float dis = distance(randomPosReal, curPos);
            if (dis <= gridW*0.7){
                mindist = dis;
                resultPos = randomPosReal;
            }
        }
    }

    return resultPos;
}

void main()
{

    gl_FragColor = vec4(1.0, 1.0, 1.0, 1.0);
    float ratioNum = ratio*0.5;
    vec2 posReal = vec2(textureCoordinate.x*realWH.x, textureCoordinate.y*realWH.y);
    float gridW = 1.0+realWH.x*0.1*ratioNum;
    gridW = floor(gridW);
    vec2 randomPosReal = getRandomPoint(posReal, gridW);
    if (randomPosReal.x != -1.0){
        gl_FragColor = texture2D(inputImageTexture, vec2(randomPosReal.x/realWH.x, randomPosReal.y/realWH.y));
    }

}