precision highp float;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform highp vec2 realWH;
uniform highp vec2 tileRealWH;
uniform highp float countOneLine;//控制一行个数 范围1~100

void main(void)
{
    vec2 realPos = vec2(textureCoordinate.x*realWH.x,textureCoordinate.y*realWH.y);
    float itemW = realWH.x/countOneLine;
    float itemH = itemW*tileRealWH.y/tileRealWH.x;
    float x_num = floor(realPos.x/itemW);
    float y_num = floor(realPos.y/itemH);
    float percentX = (realPos.x - x_num*itemW)/itemW;
    float percentY = (realPos.y - y_num*itemH)/itemH;
    vec4 tileColor = texture2D(inputImageTexture2, vec2(percentX,percentY));

    gl_FragColor = tileColor;
}