precision highp float;

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D toneCurveTexture;

uniform lowp float ratio;

void main()
{
    highp vec4 base = texture2D(inputImageTexture, textureCoordinate);
    highp float redCurveValue = texture2D(toneCurveTexture, vec2(base.r, 0.0)).r;
    highp float greenCurveValue = texture2D(toneCurveTexture, vec2(base.g, 0.5)).g;
    highp float blueCurveValue = texture2D(toneCurveTexture, vec2(base.b, 1.0)).b;
    highp vec4 textureColor2 = vec4(redCurveValue, greenCurveValue, blueCurveValue, base.a);
    gl_FragColor = vec4(mix(base.rgb, textureColor2.rgb, textureColor2.a*ratio), base.a);
}
